unit screen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, uKomplex, StdCtrls, ComCtrls;

type

  Tf_screen = class(TForm)
    i_fractal: TImage;
    i_overlay: TImage;
    sb_status: TStatusBar;
    procedure FormResize(Sender: TObject);
    procedure i_overlayMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure i_overlayMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure i_overlayMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure setmode(vp_mode:integer);
    procedure setvar(vp_z1, vp_z2, vp_c1, vp_c2: uk_r_komplex);
    procedure calc;
  end;

const
  c_julia =1;
  c_mandel = 2;

var
  f_screen: Tf_screen;

  v_onzoomrecalc : boolean = true;
  v_onresizerecalc : boolean = true;
  v_speedboost : boolean = true;
  v_mode:integer; // Julia oder Mandel

implementation

uses control;

var
  v_mousedown: boolean = false;

  v_width, v_height,
  v_x1, v_y1: integer;
  v_x, v_y, v_xpp, v_ypp: double; // x per pixel

  v_z1, v_z2, v_c1, v_c2: uk_r_komplex;
{$R *.DFM}

function getx(vp_x:integer):double;
begin
  result := v_x+(vp_x-40)*v_xpp;
end;

function gety(vp_y:integer):double;
begin
  result := v_y+(v_height-20-vp_y)*v_ypp;
end;

procedure Tf_screen.setmode(vp_mode: integer);
begin
  v_mode:=vp_mode;
  if v_mode = c_julia then caption:='Juliamenge';
  if v_mode = c_mandel then caption:='Mandelbrotmenge';
end;

procedure Tf_screen.setvar(vp_z1, vp_z2, vp_c1, vp_c2: uk_r_komplex);
begin
  v_z1:=vp_z1;
  v_z2:=vp_z2;
  v_c1:=vp_c1;
  v_c2:=vp_c2;
end;

procedure calc_speedboosted;
var
  vp_xrun, vp_yrun, vp_zrun: integer;
  vp_x2,vp_y2,vp_x,vp_x0,vp_y,vp_y0, vp_cx, vp_cy:double;
begin
  f_screen.sb_status.panels[1].text:='Speedboosted Calculating';
  if v_mode = c_julia then
    begin
      vp_cx:=v_c1.x;
      vp_cy:=v_c1.y;
      for vp_yrun:=10 to v_height-21 do
        for vp_xrun:=41 to v_width-10 do
          begin
          vp_zrun:=0;
          vp_x:=getx(vp_xrun);
          vp_Y:=gety(vp_yrun);

          // Berechnung
          repeat
            inc(vp_zrun);
            vp_x0:=vp_x;
            vp_y0:=vp_y;
            vp_x2:=sqr(vp_x0);
            vp_y2:=sqr(vp_y0);
            vp_x:=vp_x2-vp_y2+vp_cx;
            vp_y:=2*vp_x0*vp_y0+vp_cy;
          until (vp_zrun=100)or((vp_x2+vp_y2)>16);
          if vp_zrun>=100 then
            f_screen.i_fractal.picture.bitmap.Canvas.Pixels[vp_xrun,vp_yrun]:=clwhite
          else
            f_screen.i_fractal.picture.bitmap.Canvas.Pixels[vp_xrun,vp_yrun]:=vp_zrun*$20000;
        end; // for vp_xrun:=41 to v_width-10 do
    end //  if v_mode = c_julia then
  else
    begin
      for vp_yrun:=10 to v_height-21 do
        for vp_xrun:=41 to v_width-10 do
          begin
          vp_zrun:=0;
          vp_cx:=getx(vp_xrun);
          vp_cY:=gety(vp_yrun);
          vp_x:=v_z1.x;
          vp_y:=v_z1.y;

          // Berechnung
          repeat
            inc(vp_zrun);
            vp_x0:=vp_x;
            vp_y0:=vp_y;
            vp_x:=sqr(vp_x0)-sqr(vp_y0)+vp_cx;
            vp_y:=2*vp_x0*vp_y0+vp_cy;
          until (vp_zrun=100)or(sqrt(sqr(vp_x)+sqr(vp_y))>4);
          if vp_zrun>=100 then
            f_screen.i_fractal.picture.bitmap.Canvas.Pixels[vp_xrun,vp_yrun]:=clwhite
          else
            f_screen.i_fractal.picture.bitmap.Canvas.Pixels[vp_xrun,vp_yrun]:=vp_zrun*$20000;
        end; // for vp_xrun:=41 to v_width-10 do
    end; //  else

end;

procedure Tf_screen.calc;
var
  vp_newbitmap: tBitmap;
  vp_xrun, vp_yrun, vp_irun: integer;
  vp_z, vp_c: uk_r_komplex;
begin
  f_screen.sb_status.panels[1].text:='Calculating';
// Bitmaps erzeugen
  vp_newbitmap:=tbitmap.create;
  v_width:=i_fractal.Width;
  v_height:=i_fractal.height;
  vp_newbitmap.width:=v_width;
  vp_newbitmap.height:=v_height;
  i_fractal.Picture.Bitmap:=vp_newbitmap;
  i_overlay.Picture.Bitmap:=vp_newbitmap;
  vp_newbitmap.free;

// Hilfsvariablen berechnen
  if v_mode=c_julia then
    begin
      v_x:=v_z1.x;
      v_y:=v_z1.y;
      v_xpp:=(v_z2.x-v_z1.x)/(v_width-50);
      v_ypp:=(v_z2.y-v_z1.y)/(v_height-30);
    end
  else
    begin
      v_x:=v_c1.x;
      v_y:=v_c1.y;
      v_xpp:=(v_c2.x-v_c1.x)/(v_width-50);
      v_ypp:=(v_c2.y-v_c1.y)/(v_height-30);
    end;

// Koordinatenkreuz einzeichnen
  with i_fractal.Picture.Bitmap.Canvas do begin
    brush.Color:=clblack;
    fillrect(rect(0,0,v_Width,v_height));

    pen.color:=clwhite;
    moveto(40,5);
    lineto(40,v_height-15);
    moveto(35,v_height-20);
    lineto(v_width-5,v_height-20);

    moveto(35,10);
    lineto(45,10);
    moveto(v_width-10,v_height-25);
    lineto(v_width-10,v_height-15);

// "Mastab"
    font.Color:=clwhite;
    if v_mode=c_julia then
      begin
        textout(5,5,floattostrf(v_z2.y,ffFixed,4,3));
        textout(5,v_height-28,floattostrf(v_z1.y,ffFixed,4,3));
        textout(v_width-30,v_height-15,floattostrf(v_z2.x,ffFixed,4,3));
        textout(20,v_height-15,floattostrf(v_z1.x,ffFixed,4,3));
      end
    else
      begin
        textout(5,5,floattostrf(v_c2.y,ffFixed,4,3));
        textout(5,v_height-28,floattostrf(v_c1.y,ffFixed,4,3));
        textout(v_width-30,v_height-15,floattostrf(v_c2.x,ffFixed,4,3));
        textout(20,v_height-15,floattostrf(v_c1.x,ffFixed,4,3));
      end;
// Hauptschleife
    if v_speedboost then
      calc_speedboosted
    else
      for vp_yrun:=10 to v_height-21 do
        for vp_xrun:=41 to v_width-10 do
          begin
            if v_mode = c_julia then
              begin
                vp_z.x:=getx(Vp_xrun);
                vp_z.y:=gety(vp_yrun);
                vp_c:=v_c1;
              end
            else
              begin
                vp_z:=v_z1;
                vp_c.x:=getx(vp_xrun);
                vp_c.y:=gety(vp_yrun);
              end;
            vp_irun:=0;
            repeat
              vp_z:=uK_add(uK_sqr(vp_z),vp_c);
              inc(vp_irun);
            until (vp_irun=100)or(uK_betrag(vp_z)>4);
            if vp_irun=100 then pixels[vp_xrun,vp_yrun]:=$FFFFFF;
            if vp_irun<100 then pixels[vp_xrun,vp_yrun]:=2*$10000*vp_irun;
          end;
    end;
  sb_status.Panels[1].text:='wartet auf Beutzeraktion ...';
end;

procedure Tf_screen.FormResize(Sender: TObject);
begin
  if width<250 then width:=250;
  if height<100 then height:=100;
  i_fractal.Width:=width-8;
  i_fractal.height:=height-46;
  i_overlay.Width:=width-8;
  i_overlay.height:=height-46;
  f_control.b_calcclick(Sender);
end;

procedure Tf_screen.i_overlayMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  sb_status.Panels[0].text:='X: '+floattostrf(getx(x),ffFixed,5,4)+' Y: '+floattostrf(gety(y),ffFixed,5,4);
  if v_mousedown then
    begin
      i_overlay.Picture.Bitmap.Canvas.Pen.Color:=clwhite;
      i_overlay.Picture.Bitmap.Canvas.FillRect(rect(0,0,v_width,v_height));
      i_overlay.Picture.Bitmap.Canvas.Pen.Color:=clred;
      i_overlay.picture.bitmap.canvas.rectangle(rect(v_x1,v_y1,x,y));
    end
end;

procedure Tf_screen.i_overlayMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  i_overlay.Picture.Bitmap.Canvas.Pen.Color:=clred;
  v_mousedown:=true;
  v_x1:=x;
  v_y1:=y;
  if v_mode = c_julia then
    begin
      f_control.k_z1.e_x.text:=floattostr(getx(x));
      f_control.k_z2.e_y.text:=floattostr(gety(y));
    end
  else
    begin
      f_control.k_c1.e_x.text:=floattostr(getx(x));
      f_control.k_c2.e_y.text:=floattostr(gety(y));
    end;

  sb_status.Panels[1].text:='Zoommodus aktiviert';
end;

procedure Tf_screen.i_overlayMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  v_mousedown:=false;
  if v_mode = c_julia then
    begin
      f_control.k_z2.e_x.text:=floattostr(getx(x));
      f_control.k_z1.e_y.text:=floattostr(gety(y));
    end
  else
    begin
      f_control.k_c2.e_x.text:=floattostr(getx(x));
      f_control.k_c1.e_y.text:=floattostr(gety(y));
    end;
  f_control.b_calcclick(Sender);
  sb_status.Panels[1].text:='wartet auf Beutzeraktion ...';
end;

end.
