unit ukomplex;
{
Rechenen mit Komplexen Zahlen
von Mark Blumberg

Version: 0.1
Datum: 2000-12-09
}

interface

type
  uK_r_komplex= record
    x, y: double;
  end;

function uK_add(vp_sum1, vp_sum2: uK_r_komplex):uK_r_komplex;
function uK_multi(vp_faktor1, vp_faktor2: uK_r_komplex):uK_r_komplex;
function uK_sqr(vp_faktor: uK_r_komplex):uK_r_komplex;
function uK_betrag(vp_zahl: uK_r_komplex):double;

implementation

function uK_add(vp_sum1, vp_sum2: uK_r_komplex):uK_r_komplex;
var
  vp_result: uK_r_komplex;
begin
  vp_result.x:=vp_sum1.x+vp_sum2.x;
  vp_result.y:=vp_sum1.y+vp_sum2.y;
  result := vp_result;
end;

function uK_multi(vp_faktor1, vp_faktor2: uK_r_komplex):uK_r_komplex;
var
  vp_result: uK_r_komplex;
begin
  vp_result.x:=vp_faktor1.x*vp_faktor2.x-vp_faktor1.y*vp_faktor2.y;
  vp_result.y:=vp_faktor1.y*vp_faktor2.x+vp_faktor1.x*vp_faktor2.y;
  result := vp_result;
end;

function uK_sqr(vp_faktor: uK_r_komplex):uK_r_komplex;
var
  vp_result: uK_r_komplex;
begin
  vp_result.x:=sqr(vp_faktor.x)-sqr(vp_faktor.y);
  vp_result.y:=2*vp_faktor.y*vp_faktor.x;
  result := vp_result;
end;

function uK_betrag(vp_zahl: uK_r_komplex):double;
begin
  result := sqrt(sqr(vp_zahl.x)+sqr(vp_zahl.y));
end;

end.
